% Main document
%===============================================================================
% Document information
%-------------------------------------------------------------------------------
\newcommand{\documenttitle}{Bern\ RTOS}
\newcommand{\documenttitleshort}{Bern\ RTOS}
\newcommand{\documentsubtitle}{
	The goal of the Bern RTOS project is to develop a fail-safe real-time operating system (RTOS) from the ground up using the Rust programming language. This document details the RTOS process and thread model, preemptive Round-Robin scheduler, inter-process communication mechanisms and memory allocation strategies. The kernel features are showcased and tested in an espresso machine control application.
}
\newcommand{\documentauthor}{Stefan\ Lüthi}
\newcommand{\version}{2.0}
\newcommand{\versiondate}{05.08.2022}
\newcommand{\organization}{}

% Load configuration
%-------------------------------------------------------------------------------
\input{extra/paper_format.tex}
\input{extra/config.tex}

\input{lib/tikz_base.tex}
\input{lib/feature_circles.tex}

\usepackage[
    type={CC},
    modifier={by},
    version={4.0},
]{doclicense}

% some commands to make writing easier
\newcommand{\ucos}{\textmu C/OS\xspace}
\newcommand{\iic}{I\textsuperscript{2}C\xspace}

\begin{document}
	\raggedbottom % don't align page bottom, too many pictures...
	\pagenumbering{roman}

	%---------------------------------------------------------------------------
	% Leader
	%---------------------------------------------------------------------------
	\include{leader/titlepage}
	\pagestyle{normalpage}
	\include{leader/license}
	\cleardoublepage
	\include{chapters/abstract}

	%---------------------------------------------------------------------------
	% Table of contents
	%---------------------------------------------------------------------------
	\cleardoublepage
	\tableofcontents

	%---------------------------------------------------------------------------
	% Main part
	%---------------------------------------------------------------------------
	\cleardoublepage
	\pagenumbering{arabic}

	\include{chapters/introduction}

	\part{Bern RTOS Kernel}

	\include{chapters/design-overview}
	\include{chapters/getting-started}
	\include{chapters/components}
	\include{chapters/testing}
	\include{chapters/discussion}

	\part{Espresso Machine}
	\include{chapters/em-concept}
	\include{chapters/em-material-methods}
	\include{chapters/em-results}


	\part{Conclusions}
	\include{chapters/conclusions}

	%---------------------------------------------------------------------------
	% Acronyms
	%---------------------------------------------------------------------------
	%\printglossary[type=\acronymtype]
	%\addcontentsline{toc}{chapter}{Glossary}

	%---------------------------------------------------------------------------
	% Bibliography
	%---------------------------------------------------------------------------
	%\nocite{*}
    \printbibliography
	\addcontentsline{toc}{chapter}{Bibliography}

	%---------------------------------------------------------------------------
	% Listings
	%---------------------------------------------------------------------------
	\listoffigures
	\addcontentsline{toc}{chapter}{List of Figures}

	\listoftables
	\addcontentsline{toc}{chapter}{List of Tables}

	\listoflistings
	\addcontentsline{toc}{chapter}{List of Listings}
\end{document}
